function [R] = cycmult(a, X)
 
%%MATLAB function  
%%input:   a = vector of length n
%%         X = [n-by-p] matrix
%%output:  R = [n-by-p] = M*X
%%             where M is [n-by-n] symmetric Toeplitz matrix whose
%%             first row is the input vector a
 
n= length(a);
p= length(X(1,:));
R=sparse(n,p);
 
for i=1:n
        in=[-(-i:-1), 2:(n-i+1)];
        R(i,:)=a(in)*X;
end

%%for j=1:p
%%      for i=1:n
%%              in=[-(-i:-1), 2:(n-i+1)];
%%              R(i,j)=a(in)*X(:,j);
%%      end
%%end

%%  M=[a1 a2 a3 a4 ... an
%%     a2 a1 a2 a3 ... a(n-1)
%%     a3 a2 a1 a2 ... a(n-2)
%%     ...
%%     an a(n-1)   ... a1]
%%
%%i=1:  in=[1 2 3 4 ... n]
%%i=2:  in=[2 1 2 3 ...n-1] etc. 
